﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Linq;
using HeuristicLab.Clients.Hive.Views;
using HeuristicLab.MainForm;

namespace HeuristicLab.Analysis.SolutionCaching.Views {
  [View("RunCollectionModifierHiveTask View")]
  [Content(typeof(RunCollectionModifierHiveTask), true)]
  public class RunCollectionModifierHiveTaskView : HiveTaskView {
    public new RunCollectionModifierHiveTask Content {
      get { return (RunCollectionModifierHiveTask)base.Content; }
      set { base.Content = value; }
    }

    public RunCollectionModifierHiveTaskView()
      : base() {
      modifyItemButton.Text = "Show RunCollectionModifierExecutale";
    }


    protected override void modifyItemButton_Click(object sender, EventArgs e) {
      var exec = Content.ItemTask.Item;

      if (!exec.RunCollection.Any()) {
        //fill runcollection with the runs from childs
        foreach (var child in Content.ChildHiveTasks) {
          var childTask = child.ItemTask as RunCollectionModifierTask;
          exec.RunCollection.AddRange(childTask.Item.RunCollection);
        }
      }

      MainFormManager.MainForm.ShowContent(exec);
    }
  }
}
